/*
 * n01
 *
 * plugin.h
 *
 * Copyright (C) 1996-2006 by Nakashima Tomoaki. All rights reserved.
 *		http://www.nakka.com/
 *		nakka@nakka.com
 */

#ifndef _INC_PLUGIN_H
#define _INC_PLUGIN_H

/* Include Files */

/* Define */
#define BUF_SIZE						256

#define CALLTYPE_START					1				// vOJn
#define CALLTYPE_END					2				// vOI
#define CALLTYPE_MENU					4				// j[
#define CALLTYPE_SET_START				8				// ZbgJn
#define CALLTYPE_SET_END				16				// ZbgI
#define CALLTYPE_LEG_START				32				// bOJn
#define CALLTYPE_LEG_END				64				// bOI
#define CALLTYPE_INPUT_START			128				// XRA͊Jn
#define CALLTYPE_INPUT_END				256				// XRA͊m
#define CALLTYPE_FINISH					512				// tBjbV
#define CALLTYPE_PREV_LEG				1024			// ÕbOɖ߂

// vOC߂l
#define PLUGIN_ERROR					0				// vOC̃G[
#define PLUGIN_SUCCEED					1				// vOC̐I
#define PLUGIN_CANCEL					2				// ȍ~̏LZ (CALLTYPE_END, CALLTYPE_INPUT_END, CALLTYPE_FINISH)
#define PLUGIN_DATA_MODIFIED			4				// f[^ύX (CALLTYPE_INPUT_END, CALLTYPE_FINISH)

/* Struct */
// vOC擾
typedef struct _PLUGIN_GET_INFO {
	DWORD struct_size;					// \̂̃TCY

	TCHAR title[BUF_SIZE];
	TCHAR func_name[BUF_SIZE];
	TCHAR cmd_line[BUF_SIZE];
} PLUGIN_GET_INFO;

// vOCs
typedef struct _PLUGIN_EXEC_INFO {
	DWORD struct_size;					// \̂̃TCY

	TCHAR cmd_line[BUF_SIZE];			// vOCݒŎw肵R}hC
	LPARAM lParam1;						// vOCɑΉlongl
	LPARAM lParam2;						// vOCɑΉlongl

	struct _SCORE_INFO *si;
} PLUGIN_EXEC_INFO;

// vOC
typedef struct _PLUGIN_INFO {
	TCHAR title[BUF_SIZE];
	TCHAR lib_file_path[BUF_SIZE];
	TCHAR func_name[BUF_SIZE];
	int call_type;						// CALLTYPE_

	HANDLE lib;
	FARPROC func;

	PLUGIN_EXEC_INFO pei;

	int index;

	int ctrl;
	int key;
} PLUGIN_INFO;

/* Function Prototypes */
void plugin_create_accelerator(void);
void plugin_free_accelerator(void);
BOOL plugin_initialize(const HWND hWnd, struct _SCORE_INFO *si);
void plugin_free(void);
int plugin_execute(const HWND hWnd, PLUGIN_INFO *pi, const int call_type, struct _SCORE_INFO *si, int param);
int plugin_execute_all(const HWND hWnd, const int call_type, struct _SCORE_INFO *si, int param);

#endif
/* End of source */
